/* eslint-env mocha */
/* eslint-disable no-unused-expressions */

const { expect } = require('chai');
const FfmpegParsedData = require('./FfmpegParsedData');
const { inputFileMock } = require('../../test/fixtures');
require('dotenv').config();

describe('FfmpegParsedData', () => {
  describe('Unit Tests', () => {
    describe('Constructor', () => {
      it('Constructs from an object argument', () => {
        const test = new FfmpegParsedData(inputFileMock.parsedData);
        expect(test.format).to.deep.equal(inputFileMock.parsedData.format);
        expect(test.streams).to.deep.equal(inputFileMock.parsedData.streams);
      });

      it('freezes parsedData', () => {
        const test = new FfmpegParsedData(inputFileMock.parsedData);
        expect(test.format).to.be.frozen;
        expect(test.streams).to.be.frozen;
      });
    });
  });
});
