/* eslint-env mocha */
const { expect } = require('chai');
const FfmpegStream = require('../FfmpegStream/FfmpegStream');
const FfmpegSettings = require('../FfmpegSettings/FfmpegSettings');
const { inputFileMock } = require('../../test/fixtures');

describe('FfmpegStream', () => {
  describe('Unit Tests', () => {
    describe('Constructor', () => {
      it('stores parsed data in its own properties', () => {
        const test = new FfmpegStream(inputFileMock.parsedData.streams[0]);
        expect(test).to.deep.include(inputFileMock.parsedData.streams[0]);
      });

      it('creates an instance of FfmpegSettings', () => {
        const test = new FfmpegStream(inputFileMock.parsedData.streams[0]);
        expect(test.ffmpegSettings).to.be.an.instanceOf(FfmpegSettings);
      });
    });
  });

  describe('Inheritance/Composition Tests', () => {
    describe('addOption()', () => {
      it('adds an option', () => {
        const test = new FfmpegStream(inputFileMock.parsedData.streams[0]);
        test.addOption('frames', 500);
        expect(test.hasOption('frames')).to.be.true;

      });
    });
  });
});
