const FfmpegStream = require('../FfmpegStream/FfmpegStream');

module.exports = class FfmpegStreamAudio extends FfmpegStream {
  /**
   * Set the number of audio channels. For input streams this option only makes sense for audio
   * grabbing devices and raw demuxers and is mapped to the corresponding demuxer options.
   *
   * For output streams it is set by default to the number of
   * input audio channels.
   */
  ac(channels) {
    this.addOption('-ac', channels);
    return this;
  }

  /**
   * Set the audio sampling frequency. For input streams this option only makes sense for audio
   * grabbing devices and raw demuxers and is mapped to the corresponding demuxer options.
   *
   * For output streams it is set by default to the frequency of
   * the corresponding input stream.
   *
   * @param {number}
   */
  ar(freq) {
    this.addOption('ar', freq);
    return this;
  }
};
