const FfmpegStream = require('../FfmpegStream/FfmpegStream');
const FfmpegStreamAudioInput = require('../FfmpegStreamAudioInput/FfmpegStreamAudioInput');
const FfmpegStreamVideoInput = require('../FfmpegStreamVideoInput/FfmpegStreamVideoInput');
const FfmpegStreamAudioOutput = require('../FfmpegStreamAudioOutput/FfmpegStreamAudioOutput');
const FfmpegStreamVideoOutput = require('../FfmpegStreamVideoOutput/FfmpegStreamVideoOutput');

function InputStreamFactory(rawStream) {
  switch (rawStream.codec_type) {
    case 'video':
      return new FfmpegStreamVideoInput(rawStream);
    case 'audio':
      return new FfmpegStreamAudioInput(rawStream);
    default:
      return new FfmpegStream(rawStream);
  }
}

function OutputStreamFactory(rawStream) {
  switch (rawStream.codec_type) {
    case 'video':
      return new FfmpegStreamVideoOutput(rawStream);
    case 'audio':
      return new FfmpegStreamAudioOutput(rawStream);
    default:
      return new FfmpegStream(rawStream);
  }
}

module.exports = {
  InputStreamFactory,
  OutputStreamFactory,
};
